[PATCH] file writer flac does not write tags

August 24, 2013 01:05 - James Buren

Status: Closed Start date: August 24, 2013

Priority: Minor Due date:  

Assignee:  % Done: 100%

Category: plugins/filewriter Estimated time: 0.00 hour

Target version: 3.4.1   

Affects version: 3.4   

Description

Due to how this is written, the tags do not get written to the FLAC file that is

created by the plugin. The attached patch fixes 5 issues.

1) A switch case in insert_vorbis_comment() did not include a break statement, so

string tags would not be inserted because the default case has a return statement.

2) The metadata object is allocated on the stack and is not managed by libFLAC,

resulting in a memory leak. It is now a static global variable.

3) The encoder and metadata objects are both handled properly now when the file is

closed. Pointers are NULL checked, freed, and reset to NULL now.

4) FLAC__stream_encoder_init_stream() must be called after the metadata is set.

Otherwise the call will fail.

5) FLAC vorbis comments should be in uppercase, as that is what the official encoder

does.

Also, the compression level is now set to 8, the maximum. Please apply this patch.

History

#1 - August 24, 2013 18:42 - John Lindgren

This is a good start, but making flac_metadata static introduces another leak.  See if you can figure out why.

Edit: Never mind, the leak I'm thinking of shouldn't happen in normal operation.

#2 - August 24, 2013 19:07 - John Lindgren

- Status changed from New to Closed

- % Done changed from 0 to 100

- Affects version 3.4 added

- Affects version deleted (3.4.1, 3.5)

https://github.com/audacious-media-player/audacious-plugins/commit/6e050db79c35cb4d4e1e51aa2d79b0d7bd5972ad

https://github.com/audacious-media-player/audacious-plugins/commit/d3b127b53e7f78b73e0555d581af84c8ec545320

#3 - August 24, 2013 19:09 - John Lindgren

James Buren wrote:

Also, the compression level is now set to 8, the maximum.

 

July 12, 2025 1/2

https://github.com/audacious-media-player/audacious-plugins/commit/6e050db79c35cb4d4e1e51aa2d79b0d7bd5972ad
https://github.com/audacious-media-player/audacious-plugins/commit/d3b127b53e7f78b73e0555d581af84c8ec545320


DO NOT EVER add arbitrary changes like this to an otherwise legitimate bug-fix patch.

#4 - August 24, 2013 19:10 - John Lindgren

James Buren wrote:

5) FLAC vorbis comments should be in uppercase, as that is what the official encoder

does.

 

Actually, Vorbis comments are case-insensitive, so either way is fine.

Files
